#include <cloud.h>
#include <fstream>
#include <iostream>
#include <float.h>

using namespace std;

void cloud::get_size(double &scale, vector3f &center){
  vector3f m,M;
  center = 0;

   m = vector3f(FLT_MAX, FLT_MAX, FLT_MAX);
   M = vector3f(-FLT_MAX, -FLT_MAX, -FLT_MAX);
   
   for (unsigned int i=0; i<size(); i++) {
     m = m.vmin(at(i));
     M = M.vmax(at(i));
   }

   cout << m << endl;
   cout << M << endl;

   vector3f diam = M-m;

   scale = fabs(diam.x);
   if (fabs(diam.y)>scale) scale = fabs(diam.y);
   if (fabs(diam.z)>scale) scale = fabs(diam.z);
   //   scale = 1.0f/scale;
  
   center = 0.5f*(m + M);
}

void cloud::load_file(const std::string name){

  clear();
  normals.clear();
  ifstream fin(name.c_str(),ios::in);

  if(!fin.is_open()){
    cout << "Cannot Read the file " << name << endl;
    return;
  }

  vector3f pos, norm;
  while(true){
    fin >> pos >> norm;

    if(!fin.fail()){
      push_back(pos);
    
      normals.push_back(norm);
    }
    else{
      break;
    }
  }

  fin.close();

}
     
