#include "ANN.h"
#include "vector3f.h"
#include "cloud.h"

class kdtree{

private:
   ANNkd_tree *_kdtree;
   ANNpointArray _dataPts;


public:

  kdtree(cloud *points){

    _dataPts = annAllocPts(points->size(), 3); // allocate data points

    for(unsigned int i=0;i<points->size();i++){
      for(int j=0;j<3;j++)
	_dataPts[i][j] = (*points)[i][j];
    }

    _kdtree = new ANNkd_tree( _dataPts, points->size(), 3);

  }

  void find_knn(vector3f query, unsigned int k, vector<unsigned int> &idx, vector<double> &dist){
     if(_kdtree == NULL){
       cout << "Build the kdtree first" << endl;
     }

     ANNpoint queryPt = annAllocPt(3);

     for(int j=0;j<3;j++){
       queryPt[j] = query[j];
     }

     ANNidxArray nnIdx = new ANNidx[k];
     ANNdistArray dists = new ANNdist[k];

     _kdtree->annkSearch( // search
			 queryPt, // query point
			 k, // number of near neighbors
			 nnIdx, // nearest neighbors (returned)
			 dists,
			 0);

     idx.clear();
     dist.clear();
     for(unsigned int i=0;i<k;i++){
       idx.push_back(nnIdx[i]);
       dist.push_back(dists[i]);
     }
  }

};

