#include "ANN.h"
#include "vector3f"
#include "cloud.h"

class kdtree{

private:
   ANNkd_tree *_kdtree;
   ANNpointArray _dataPts;


public:

  void kdtree(cloud *points){

    dataPts = annAllocPts(size(), 3); // allocate data points

    for(unsigned int i=0;i<size();i++){
      for(int j=0;j<3;j++)
	dataPts[i][j] = (*this)[i][j];
    }

    _kdtree = new ANNkd_tree( dataPts, size(), 3);

  }

  void find_knn(vector3f query, unsigned int k, vector<unsigned int> &idx){
     if(_kdtree == NULL){
       cout << "Build the kdtree first" << endl;
     }

     ANNpoint queryPt = annAllocPt(3);

     for(int j=0;j<3;j++){
       queryPt[j] = query[j];
     }

     ANNidxArray nnIdx = new ANNidx[k];
     ANNdistArray dists = new ANNdist[k];

     _kdtree->annkSearch( // search
			 queryPt, // query point
			 k, // number of near neighbors
			 nnIdx, // nearest neighbors (returned)
			 dists,
			 0);

     idx.clear();
     for(int i=0;i<k;i++){
       idx.push_back(nnIdx[i]);
     }
  }

}

