#ifndef WIDGET_H
#define WIDGET_H

#include <qgl.h>
#include <qevent.h>
#include "director.h"

   class GLWidget : public QGLWidget
   {
	 Q_OBJECT
	 
	 public:
	 GLWidget(QWidget* parent);
	 ~GLWidget();
	 
      protected:
	 void initializeGL();
	 void prepaintGL();
	 void postpaintGL();
	 void resizeGL(int w, int h);

	 void mouseMoveEvent (QMouseEvent* e);
	 void mousePressEvent (QMouseEvent* e);
	 void wheelEvent (QWheelEvent* e);

	 void keyPressEvent (QKeyEvent* e);

      private:
	 // xside = half of the width of the window
	 // yside = half of the height of the window
	 // side = min(xside, yside)
	 int side, xside, yside;

	 // actual and previous positions of the mouse
	 int x, y, xold, yold;

	 // tell wether the left, right or middle botton is pressed
	 int pushedL, pushedR, pushedM;
	 bool shifting;
	 double rayon;
   public:
	 Director b;

   };

#endif // WIDGET_H
